boolean get_usb_data() {
  if ( getSerialString() ) {
    board = toupper(dataBuffer[1]);
    relay = atoi(&dataBuffer[2]);
    cmd = toupper(dataBuffer[3]);
    execute = 1;
    // first param is board, A - D
    if (!(board >= 'A' && board <= 'D')) {execute = 0;} // board check

    // second is relay, 0 through 8
    if (!(relay >= 0 && relay <= 8)) {execute = 0;} // relay check

    // third is command -- H, S, or U
    if (!((cmd == 'H') || (cmd == 'S') || (cmd == 'U'))) {execute = 0;} // cmd check
  
  } //call getSerialString
  return execute;
} //get_usb_data

boolean getSerialString(){
    static byte dataBufferIndex = 0;
    boolean storeString;
    while(Serial.available()>0){
        char incomingbyte = Serial.read();
        if(incomingbyte==startChar){
            dataBufferIndex = 0;  //Initialize our dataBufferIndex variable
            storeString = true;
        }
        if(storeString){
            // Abort if index outside buffer size
            if(dataBufferIndex==DATABUFFERSIZE){
                dataBufferIndex = 0;
                break;
            }
            if(incomingbyte==endChar){
                dataBuffer[dataBufferIndex] = 0; //null terminate the C string
                //Data string is complete.
                storeString = false;
                return true;
            }
    else{
                dataBuffer[dataBufferIndex++] = incomingbyte;
                dataBuffer[dataBufferIndex] = 0; //null terminate the C string
            }
        }
        else{
        }
    }

    //All data read; no valid string
    return false;
}
